# PNotifierFunctionTemplate< ParmType > Class Template Reference

This is an abstract class for which a descendent is declared for every function that may be called. More...

`#include <notifier.h>`

Inheritance diagram for PNotifierFunctionTemplate< ParmType >:

List of all members.

## Public Member Functions

| PNotifierFunctionTemplate (void *obj)
| Create a notification function instance.
virtual void | Call (PObject &notifier, ParmType extra) const =0
| Execute the call to the actual notification function on the object instance contained in this object.

## Protected Attributes

void * | object
| Object instance to receive the notification function call.

## Detailed Description

### template<typename ParmType>
class PNotifierFunctionTemplate< ParmType >

This is an abstract class for which a descendent is declared for every function that may be called.

The `PDECLARE_NOTIFIER` macro makes this declaration.

The `PNotifier` and `PNotifierFunction` classes build a completely type safe mechanism for calling arbitrary member functions on classes. The "pointer to a member function" capability built into C++ makes the assumption that the function name exists in an ancestor class. If you wish to call a member function name that does not exist in any ancestor class, very type unsafe casting of the member functions must be made. Some compilers will even refuse to do it at all!

To overcome this problem, as this mechanism is highly desirable for callback functions in the GUI part of the PTLib library, these classes and a macro are used to create all the classes and declarations to use polymorphism as the link between the caller, which has no knowledege of the function, and the receiver object and member function.

This is most often used as the notification of actions being take by interactors in the PTLib library.

## Constructor & Destructor Documentation

template<typename ParmType>

PNotifierFunctionTemplate< ParmType >::PNotifierFunctionTemplate | ( | void * | obj | ) | `[inline]`

Create a notification function instance.

Parameters:

  obj | Object instance on which the function will be called on.

## Member Function Documentation

template<typename ParmType>

virtual void PNotifierFunctionTemplate< ParmType >::Call | ( | PObject & | notifier,
|  | ParmType | extra |
| ) |  |  | const`[pure virtual]`

Execute the call to the actual notification function on the object instance contained in this object.

Parameters:

  notifier | Object that is making the notification.
  extra | Extra information that may be passed to function.

## Member Data Documentation

template<typename ParmType>

void* PNotifierFunctionTemplate< ParmType >::object `[protected]`

Object instance to receive the notification function call.

The documentation for this class was generated from the following file:

- notifier.h